Index: issm/trunk/src/c/classes/IoModel.cpp
===================================================================
--- issm/trunk/src/c/classes/IoModel.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/IoModel.cpp	(revision 13975)
@@ -17,7 +17,6 @@
 #include "./classes.h"
 #include "../io/io.h"
-#include "./Container/Parameters.h"
+#include "../Container/Parameters.h"
 #include "../shared/shared.h"
-#include "../io/io.h"
 #include "../include/include.h"
 
@@ -28,5 +27,5 @@
 	this->independents=NULL;
 	this->constants=NULL;
-	
+
 	this->my_elements=NULL;
 	this->my_nodes=NULL;
@@ -34,5 +33,5 @@
 	this->singlenodetoelementconnectivity=NULL;
 	this->numbernodetoelementconnectivity=NULL;
-	
+
 	this->nodecounter=0;
 	this->loadcounter=0;
@@ -42,5 +41,5 @@
 /*FUNCTION IoModel::IoModel(FILE*  iomodel_handle){{{*/
 IoModel::IoModel(FILE* iomodel_handle){
-	
+
 	/*First, keep track of the file handle: */
 	this->fid=iomodel_handle;
@@ -48,4 +47,13 @@
 	/*Check that Enums are Synchronized*/
 	this->CheckEnumSync();
+
+	/*Initialize data: */
+	this->data=xNew<IssmDouble*>(MaximumNumberOfEnums);
+	for(int i=0;i<MaximumNumberOfEnums;i++) this->data[i]=NULL;
+
+	/*If we are running in AD mode, we need to start the trace and declare our independent variables now, 
+	 *and prevent them from being erased during successive calls to iomodel->FetchConstants, iomodel->FetchData and 
+	 iomodel->DeleteData:*/
+	this->DeclareIndependents();
 
 	/*Initialize and read constants:*/
@@ -53,12 +61,4 @@
 	this->FetchConstants(); /*this routine goes through the input file, and fetches bools, ints, IssmDoubles and strings only, nothing memory intensive*/
 
-	/*Initialize data: */
-	this->data=xNew<IssmDouble*>(MaximumNumberOfEnums);
-	for(int i=0;i<MaximumNumberOfEnums;i++) this->data[i]=NULL;
-
-	/*Initialize array detecting whether data[i] is an independent AD mode variable: */
-	this->independents=xNew<bool>(MaximumNumberOfEnums);
-	for(int i=0;i<MaximumNumberOfEnums;i++) this->independents[i]=false;
-	
 	/*Initialize permanent data: */
 	this->my_elements=NULL;
@@ -67,5 +67,5 @@
 	this->singlenodetoelementconnectivity=NULL;
 	this->numbernodetoelementconnectivity=NULL;
-	
+
 	this->nodecounter=0;
 	this->loadcounter=0;
@@ -91,4 +91,5 @@
 	xDelete<IssmDouble*>(this->data);
 	xDelete<bool>(this->independents);
+	if(this->independent_objects)delete this->independent_objects;
 	xDelete<bool>(this->my_elements);
 	xDelete<bool>(this->my_nodes);
@@ -102,6 +103,9 @@
 void  IoModel::CheckEnumSync(void){
 
-	extern int my_rank;
+	int my_rank;
 	int record_enum = 0;
+
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
 
 	/*Check that some fields have been allocated*/
@@ -182,8 +186,8 @@
 
 	/*Find constant*/
-	Param* param=(Param*)this->constants->FindParamObject(constant_enum);
+	Param* param=dynamic_cast<Param*>(this->constants->FindParamObject(constant_enum));
 	if(!param) _error_("Constant " << EnumToStringx(constant_enum) << " not found in iomodel");
 
-	return (Param*)param->copy();
+	return dynamic_cast<Param*>(param->copy());
 }
 /*}}}*/
@@ -195,4 +199,68 @@
 
 	return this->data[data_enum];
+}
+/*}}}*/
+/*FUNCTION IoModel::DeclareIndependents{{{*/
+void IoModel::DeclareIndependents(void){
+
+	int         i;
+	bool        autodiff                = false;
+	int         num_independent_objects;
+
+	int *names = NULL;
+	int *types = NULL;
+
+	int         numberofvertices;
+	int         dummy;
+	bool        keep=false;
+
+	/*Initialize array detecting whether data[i] is an independent AD mode variable: */
+	this->independents=xNew<bool>(MaximumNumberOfEnums);
+	for(i=0;i<MaximumNumberOfEnums;i++) this->independents[i]=false;
+
+	this->FetchData(&autodiff,AutodiffIsautodiffEnum);
+	if(autodiff){
+
+		this->FetchData(&numberofvertices,MeshNumberofverticesEnum);
+
+		#ifdef _HAVE_ADOLC_
+
+		/*Start trace: {{{*/
+		this->FetchData(&keep,AutodiffKeepEnum);
+		if(keep)trace_on(1,1);
+		else    trace_on(1);
+
+		/*}}}*/
+		/*build dataset made of independent objects: {{{*/
+		this->independent_objects=new DataSet();
+		this->FetchData(&num_independent_objects,AutodiffNumIndependentObjectsEnum);
+		if(num_independent_objects){
+			this->FetchData(&names,&dummy,&dummy,AutodiffIndependentObjectNamesEnum);
+			this->FetchData(&types,&dummy,&dummy,AutodiffIndependentObjectTypesEnum);
+
+			/*create independent objects, and at the same time, fetch the corresponding independent variables, 
+			 *and declare them as such in ADOLC: */
+			for(i=0;i<num_independent_objects;i++){
+
+				IndependentObject* independent_object=NULL;
+				independent_object=new IndependentObject(names[i],types[i],numberofvertices);
+
+				/*add to independent_objects dataset:*/
+				this->independent_objects->AddObject(independent_object);
+
+				/*now go fetch the independent variable: */
+				independent_object->FetchIndependent(this); //supply the pointer to iomodel.
+			}
+			xDelete<int>(names);
+			xDelete<int>(types);
+		} /*}}}*/
+
+		#else
+		/*if we asked for AD computations, we have a problem!: */
+		_error_("Cannot carry out AD mode computations without support of ADOLC compiled in!");
+		#endif
+	}
+	else this->independent_objects=NULL;
+
 }
 /*}}}*/
@@ -211,5 +279,5 @@
 		dataenum=va_arg(ap, int);
 		_assert_(dataenum<MaximumNumberOfEnums);
-		
+
 		/*do not erase independent variables for the AD mode computations!: */
 		if (!this->independents[dataenum]) xDelete<IssmDouble>(this->data[dataenum]);
@@ -227,7 +295,6 @@
 void  IoModel::FetchConstants(void){
 
-	extern int my_rank;
-	extern int num_procs;
-	
+	int my_rank;
+
 	/*record descriptions; */
 	int record_enum;
@@ -238,7 +305,11 @@
 	int  booleanint=0;
 	int  integer=0;
-	IssmPDouble scalar=0;
+	IssmPDouble pscalar=0;
+	IssmDouble scalar=0;
 	char* string=NULL;
 	int   string_size;
+
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
 
 	/*Check that some fields have been allocated*/
@@ -248,5 +319,5 @@
 	/*Go find in the binary file, the position of the data we want to fetch: */
 	if(my_rank==0){ //cpu 0{{{
-	
+
 		/*First set FILE* position to the beginning of the file: */
 		fseek(this->fid,0,SEEK_SET);
@@ -259,23 +330,23 @@
 				record_code=0; //0 means bailout
 				#ifdef _HAVE_MPI_
-				MPI_Bcast(&record_code,1,MPI_INT,0,MPI_COMM_WORLD);  /*tell others cpus we are bailing: */
+				MPI_Bcast(&record_code,1,MPI_INT,0,IssmComm::GetComm());  /*tell others cpus we are bailing: */
 				#endif
 				break;
 			}
 			else{
-			
+
 				/* Read the record length and the data type code: */
 				fread(&record_length,sizeof(int),1,this->fid);
 				fread(&record_code,sizeof(int),1,this->fid);
-					
+
 				#ifdef _HAVE_MPI_
 				/*Tell other cpus what we are doing: */
-				MPI_Bcast(&record_code,1,MPI_INT,0,MPI_COMM_WORLD);  /*tell other cpus what we are going to do: */
+				MPI_Bcast(&record_code,1,MPI_INT,0,IssmComm::GetComm());  /*tell other cpus what we are going to do: */
 
 				/*Tell other cpus the name of the data, then branch according to the data type: */
-				MPI_Bcast(&record_enum,1,MPI_INT,0,MPI_COMM_WORLD);  
-				MPI_Bcast(&record_length,1,MPI_INT,0,MPI_COMM_WORLD);  
+				MPI_Bcast(&record_enum,1,MPI_INT,0,IssmComm::GetComm());  
+				MPI_Bcast(&record_length,1,MPI_INT,0,IssmComm::GetComm());  
 				#endif
-				
+
 				switch(record_code){
 					case 1: 
@@ -283,5 +354,5 @@
 						if(fread(&booleanint,sizeof(int),1,this->fid)!=1) _error_("could not read boolean ");
 						#ifdef _HAVE_MPI_
-						MPI_Bcast(&booleanint,1,MPI_INT,0,MPI_COMM_WORLD); 
+						MPI_Bcast(&booleanint,1,MPI_INT,0,IssmComm::GetComm()); 
 						#endif
 
@@ -294,5 +365,5 @@
 						if(fread(&integer,sizeof(int),1,this->fid)!=1) _error_("could not read integer ");
 						#ifdef _HAVE_MPI_
-						MPI_Bcast(&integer,1,MPI_INT,0,MPI_COMM_WORLD); 
+						MPI_Bcast(&integer,1,MPI_INT,0,IssmComm::GetComm()); 
 						#endif
 
@@ -302,9 +373,17 @@
 						break;
 					case 3:
-						/*Read the scalar and broadcast it to other cpus:*/
-						if(fread(&scalar,sizeof(IssmPDouble),1,this->fid)!=1) _error_("could not read scalar ");
-						#ifdef _HAVE_MPI_
-						MPI_Bcast(&scalar,1,MPI_DOUBLE,0,MPI_COMM_WORLD); 
-						#endif
+						/*Read the scalar and broadcast it to other cpus. However, if this record has already 
+						 * been read in DeclareIndependents, we should not re-read it, but grab it from the iomodel->data 
+						 * slots: */
+						if(this->independents[record_enum]){
+							scalar=*(this->data[record_enum]);
+						}
+						else{
+							if(fread(&pscalar,sizeof(IssmPDouble),1,this->fid)!=1) _error_("could not read scalar ");
+							#ifdef _HAVE_MPI_
+							MPI_Bcast(&pscalar,1,MPI_DOUBLE,0,IssmComm::GetComm()); 
+							#endif
+							scalar=reCast<IssmDouble>(pscalar);
+						}
 
 						/*create DoubleParam: */
@@ -316,5 +395,5 @@
 						if(fread(&string_size,sizeof(int),1,this->fid)!=1) _error_("could not read length of string ");
 						#ifdef _HAVE_MPI_
-						MPI_Bcast(&string_size,1,MPI_INT,0,MPI_COMM_WORLD); 
+						MPI_Bcast(&string_size,1,MPI_INT,0,IssmComm::GetComm()); 
 						#endif
 
@@ -326,5 +405,5 @@
 							if(fread(string,string_size*sizeof(char),1,this->fid)!=1)_error_(" could not read string ");
 							#ifdef _HAVE_MPI_
-							MPI_Bcast(string,string_size,MPI_CHAR,0,MPI_COMM_WORLD); 
+							MPI_Bcast(string,string_size,MPI_CHAR,0,IssmComm::GetComm()); 
 							#endif
 						}
@@ -333,5 +412,5 @@
 							string[0]='\0';
 						}
-						
+
 						/*Add string to parameters: */
 						this->constants->AddObject(new StringParam(record_enum,string));
@@ -384,16 +463,16 @@
 	else{ //cpu ~0 {{{
 		for(;;){ //wait on cpu 0
-			MPI_Bcast(&record_code,1,MPI_INT,0,MPI_COMM_WORLD);  /*get from cpu 0 what we are going to do: */
+			MPI_Bcast(&record_code,1,MPI_INT,0,IssmComm::GetComm());  /*get from cpu 0 what we are going to do: */
 			if(record_code==0){
 				break; //we are done, break from the loop
 			}
 			else{
-				MPI_Bcast(&record_enum,1,MPI_INT,0,MPI_COMM_WORLD);   //get from cpu 0 name of the data
-				MPI_Bcast(&record_length,1,MPI_INT,0,MPI_COMM_WORLD);  
+				MPI_Bcast(&record_enum,1,MPI_INT,0,IssmComm::GetComm());   //get from cpu 0 name of the data
+				MPI_Bcast(&record_length,1,MPI_INT,0,IssmComm::GetComm());  
 				switch(record_code){
 				case 1: 
 					/*boolean. get it from cpu 0 */
-					MPI_Bcast(&booleanint,1,MPI_INT,0,MPI_COMM_WORLD); 
-						
+					MPI_Bcast(&booleanint,1,MPI_INT,0,IssmComm::GetComm()); 
+
 					/*create BoolParam: */
 					this->constants->AddObject(new BoolParam(record_enum,(bool)booleanint)); //cast to a boolean
@@ -402,6 +481,6 @@
 				case 2:
 					/*integer. get it from cpu 0 */
-					MPI_Bcast(&integer,1,MPI_INT,0,MPI_COMM_WORLD); 
-						
+					MPI_Bcast(&integer,1,MPI_INT,0,IssmComm::GetComm()); 
+
 					/*create IntParam: */
 					this->constants->AddObject(new IntParam(record_enum,integer));
@@ -410,6 +489,6 @@
 				case 3:
 					/*scalar. get it from cpu 0 */
-					MPI_Bcast(&scalar,1,MPI_DOUBLE,0,MPI_COMM_WORLD); 
-						
+					MPI_Bcast(&scalar,1,MPI_DOUBLE,0,IssmComm::GetComm()); 
+
 					/*create DoubleParam: */
 					this->constants->AddObject(new DoubleParam(record_enum,scalar));
@@ -417,5 +496,5 @@
 					break;
 				case 4: 
-					MPI_Bcast(&string_size,1,MPI_INT,0,MPI_COMM_WORLD); 
+					MPI_Bcast(&string_size,1,MPI_INT,0,IssmComm::GetComm()); 
 					if(string_size){
 						string=xNew<char>((string_size+1));
@@ -423,5 +502,5 @@
 
 						/*Read string from cpu 0: */
-						MPI_Bcast(string,string_size,MPI_CHAR,0,MPI_COMM_WORLD); 
+						MPI_Bcast(string,string_size,MPI_CHAR,0,IssmComm::GetComm()); 
 					}
 					else{
@@ -447,5 +526,4 @@
 				}
 
-
 			}
 		}
@@ -457,17 +535,18 @@
 void  IoModel::FetchData(bool* pboolean,int data_enum){
 
-	extern int my_rank;
-	extern int num_procs;
-	
+	int my_rank;
 
 	/*output: */
 	int   booleanint;
 	int   code;
-	
+
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
+
 	/*Set file pointer to beginning of the data: */
 	fid=this->SetFilePointerToData(&code,NULL,data_enum);
 
 	if(code!=1)_error_("expecting a boolean for enum " << EnumToStringx(data_enum));
-	
+
 	/*We have to read a boolean from disk. */
 	if(my_rank==0){  
@@ -475,5 +554,5 @@
 	}
 	#ifdef _HAVE_MPI_
-	MPI_Bcast(&booleanint,1,MPI_INT,0,MPI_COMM_WORLD); 
+	MPI_Bcast(&booleanint,1,MPI_INT,0,IssmComm::GetComm()); 
 	#endif
 
@@ -487,16 +566,18 @@
 void  IoModel::FetchData(int* pinteger,int data_enum){
 
-	extern int my_rank;
-	extern int num_procs;
+	int my_rank;
 
 	/*output: */
 	int   integer;
 	int   code;
-	
+
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
+
 	/*Set file pointer to beginning of the data: */
 	fid=this->SetFilePointerToData(&code,NULL,data_enum);
-	
+
 	if(code!=2)_error_("expecting an integer for enum " << EnumToStringx(data_enum));
-	
+
 	/*We have to read a integer from disk. First read the dimensions of the integer, then the integer: */
 	if(my_rank==0){  
@@ -505,5 +586,5 @@
 
 	#ifdef _HAVE_MPI_
-	MPI_Bcast(&integer,1,MPI_INT,0,MPI_COMM_WORLD); 
+	MPI_Bcast(&integer,1,MPI_INT,0,IssmComm::GetComm()); 
 	#endif
 
@@ -515,8 +596,5 @@
 void  IoModel::FetchData(IssmDouble* pscalar,int data_enum){
 
-
-	extern int my_rank;
-	extern int num_procs;
-	
+	int my_rank;
 
 	/*output: */
@@ -524,9 +602,12 @@
 	int      code;
 
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
+
 	/*Set file pointer to beginning of the data: */
 	fid=this->SetFilePointerToData(&code,NULL,data_enum);
-	
+
 	if(code!=3)_error_("expecting a IssmDouble for enum " << EnumToStringx(data_enum));
-	
+
 	/*We have to read a scalar from disk. First read the dimensions of the scalar, then the scalar: */
 	if(my_rank==0){
@@ -534,10 +615,10 @@
 	}
 	#ifdef _HAVE_MPI_
-	MPI_Bcast(&scalar,1,MPI_DOUBLE,0,MPI_COMM_WORLD); 
+	MPI_Bcast(&scalar,1,MPI_DOUBLE,0,IssmComm::GetComm()); 
 	#endif
 
 	/*Assign output pointers: */
 	*pscalar=scalar;
-		 
+
 }
 /*}}}*/
@@ -545,7 +626,5 @@
 void  IoModel::FetchData(char** pstring,int data_enum){
 
-	extern int my_rank;
-	extern int num_procs;
-	
+	int my_rank;
 
 	/*output: */
@@ -554,11 +633,14 @@
 	int code=0;
 
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
+
 	/*Set file pointer to beginning of the data: */
 	fid=this->SetFilePointerToData(&code,NULL,data_enum);
-	
+
 	if(code!=4)_error_("expecting a string for enum " << EnumToStringx(data_enum));
-	
+
 	/*Now fetch: */
-	
+
 	/*We have to read a string from disk. First read the dimensions of the string, then the string: */
 	if(my_rank==0){  
@@ -567,5 +649,5 @@
 
 	#ifdef _HAVE_MPI_
-	MPI_Bcast(&string_size,1,MPI_INT,0,MPI_COMM_WORLD); 
+	MPI_Bcast(&string_size,1,MPI_INT,0,IssmComm::GetComm()); 
 	#endif
 
@@ -580,5 +662,5 @@
 		}
 		#ifdef _HAVE_MPI_
-		MPI_Bcast(string,string_size,MPI_CHAR,0,MPI_COMM_WORLD); 
+		MPI_Bcast(string,string_size,MPI_CHAR,0,IssmComm::GetComm()); 
 		#endif
 	}
@@ -588,5 +670,4 @@
 	}
 
-
 	/*Assign output pointers: */
 	*pstring=string;
@@ -596,6 +677,5 @@
 void  IoModel::FetchData(int** pmatrix,int* pM,int* pN,int data_enum){
 
-	extern int my_rank;
-	extern int num_procs;
+	int my_rank;
 	int i,j;
 
@@ -607,4 +687,6 @@
 	int vector_type=0;
 
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
 
 	/*Set file pointer to beginning of the data: */
@@ -612,5 +694,5 @@
 
 	if((code!=5) && (code!=6) && (code!=7))_error_("expecting a IssmDouble, integer or boolean matrix for enum " << EnumToStringx(data_enum));
-	
+
 	/*Now fetch: */
 
@@ -622,5 +704,5 @@
 
 	#ifdef _HAVE_MPI_
-	MPI_Bcast(&M,1,MPI_INT,0,MPI_COMM_WORLD); 
+	MPI_Bcast(&M,1,MPI_INT,0,IssmComm::GetComm()); 
 	#endif
 
@@ -629,5 +711,5 @@
 	}
 	#ifdef _HAVE_MPI_
-	MPI_Bcast(&N,1,MPI_INT,0,MPI_COMM_WORLD);
+	MPI_Bcast(&N,1,MPI_INT,0,IssmComm::GetComm());
 	#endif
 
@@ -640,7 +722,7 @@
 			if(fread(matrix,M*N*sizeof(IssmPDouble),1,fid)!=1) _error_("could not read matrix ");
 		}
-		
+
 		#ifdef _HAVE_MPI_
-		MPI_Bcast(matrix,M*N,MPI_DOUBLE,0,MPI_COMM_WORLD); 
+		MPI_Bcast(matrix,M*N,MPI_DOUBLE,0,IssmComm::GetComm()); 
 		#endif
 	}
@@ -671,6 +753,5 @@
 void  IoModel::FetchData(IssmDouble** pmatrix,int* pM,int* pN,int data_enum){
 
-	extern int my_rank;
-	extern int num_procs;
+	int my_rank;
 
 	/*output: */
@@ -680,8 +761,11 @@
 	int vector_type=0;
 
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
+
 	/*Set file pointer to beginning of the data: */
 	fid=this->SetFilePointerToData(&code,&vector_type,data_enum);
 	if((code!=5) && (code!=6) && (code!=7))_error_("expecting a IssmDouble, integer or boolean matrix for enum " << EnumToStringx(data_enum));
-	
+
 	/*Now fetch: */
 
@@ -692,5 +776,5 @@
 	}
 	#ifdef _HAVE_MPI_
-	MPI_Bcast(&M,1,MPI_INT,0,MPI_COMM_WORLD); 
+	MPI_Bcast(&M,1,MPI_INT,0,IssmComm::GetComm()); 
 	#endif
 
@@ -699,5 +783,5 @@
 	}
 	#ifdef _HAVE_MPI_
-	MPI_Bcast(&N,1,MPI_INT,0,MPI_COMM_WORLD); 
+	MPI_Bcast(&N,1,MPI_INT,0,IssmComm::GetComm()); 
 	#endif
 
@@ -711,5 +795,5 @@
 		}
 		#ifdef _HAVE_MPI_
-		MPI_Bcast(matrix,M*N,MPI_DOUBLE,0,MPI_COMM_WORLD); 
+		MPI_Bcast(matrix,M*N,MPI_DOUBLE,0,IssmComm::GetComm()); 
 		#endif
 
@@ -736,7 +820,6 @@
 void  IoModel::FetchData(char*** pstrings,int* pnumstrings,int data_enum){
 
-	extern int my_rank;
-	extern int num_procs;
-	
+	int my_rank;
+
 	int i;
 
@@ -744,15 +827,18 @@
 	int   numstrings=0;
 	char** strings=NULL;
-	
+
 	/*intermediary: */
 	char* string=NULL;
 	int   string_size;
 	int   code;
-	
+
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
+
 	/*Set file pointer to beginning of the data: */
 	fid=this->SetFilePointerToData(&code,NULL,data_enum);
-	
+
 	if(code!=9)_error_("expecting a string array for enum " << EnumToStringx(data_enum));
-	
+
 	/*We have to read a bunch of strings from disk. First read the number of strings, and allocate: */
 	if(my_rank==0){  
@@ -760,5 +846,5 @@
 	}
 	#ifdef _HAVE_MPI_
-	MPI_Bcast(&numstrings,1,MPI_INT,0,MPI_COMM_WORLD); 
+	MPI_Bcast(&numstrings,1,MPI_INT,0,IssmComm::GetComm()); 
 	#endif
 
@@ -770,10 +856,10 @@
 		/*Go through strings, and read: */
 		for(i=0;i<numstrings;i++){
-			
+
 			if(my_rank==0){  
 				if(fread(&string_size,sizeof(int),1,fid)!=1) _error_("could not read length of string ");
 			}
 			#ifdef _HAVE_MPI_
-			MPI_Bcast(&string_size,1,MPI_INT,0,MPI_COMM_WORLD); 
+			MPI_Bcast(&string_size,1,MPI_INT,0,IssmComm::GetComm()); 
 			#endif
 			if(string_size){
@@ -786,5 +872,5 @@
 				}
 				#ifdef _HAVE_MPI_
-				MPI_Bcast(string,string_size,MPI_CHAR,0,MPI_COMM_WORLD); 
+				MPI_Bcast(string,string_size,MPI_CHAR,0,IssmComm::GetComm()); 
 				#endif
 			}
@@ -808,6 +894,5 @@
 	int i;
 
-	extern int my_rank;
-	extern int num_procs;
+	int my_rank;
 
 	/*output: */
@@ -821,9 +906,12 @@
 	IssmPDouble *matrix = NULL;
 	int     code;
-	
+
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
+
 	/*Set file pointer to beginning of the data: */
 	fid=this->SetFilePointerToData(&code,NULL,data_enum);
 	if(code!=8)_error_("expecting a IssmDouble mat array for enum " << EnumToStringx(data_enum));
-	
+
 	/*Now fetch: */
 	if(my_rank==0){  
@@ -831,5 +919,5 @@
 	}
 	#ifdef _HAVE_MPI_
-	MPI_Bcast(&numrecords,1,MPI_INT,0,MPI_COMM_WORLD); 
+	MPI_Bcast(&numrecords,1,MPI_INT,0,IssmComm::GetComm()); 
 	#endif
 
@@ -854,5 +942,5 @@
 			}
 			#ifdef _HAVE_MPI_
-			MPI_Bcast(&M,1,MPI_INT,0,MPI_COMM_WORLD); 
+			MPI_Bcast(&M,1,MPI_INT,0,IssmComm::GetComm()); 
 			#endif
 
@@ -861,5 +949,5 @@
 			}
 			#ifdef _HAVE_MPI_
-			MPI_Bcast(&N,1,MPI_INT,0,MPI_COMM_WORLD); 
+			MPI_Bcast(&N,1,MPI_INT,0,IssmComm::GetComm()); 
 			#endif
 
@@ -874,5 +962,5 @@
 
 				#ifdef _HAVE_MPI_
-				MPI_Bcast(matrix,M*N,MPI_DOUBLE,0,MPI_COMM_WORLD); 
+				MPI_Bcast(matrix,M*N,MPI_DOUBLE,0,IssmComm::GetComm()); 
 				#endif
 				matrices[i]=xNew<IssmDouble>(M*N);
@@ -897,7 +985,4 @@
 /*FUNCTION IoModel::FetchData(Option**  poption,int data_enum){{{*/
 void  IoModel::FetchData(Option** poption,int index){
-
-	extern int my_rank;
-	extern int num_procs;
 
 	/*output: */
@@ -955,10 +1040,10 @@
 	/*Go through the entire list of enums and fetch the corresponding data. Add it to the iomodel->data dataset. Everything
 	 *we fetch is a IssmDouble* : */
-	
+
 	va_start(ap,num);
 	for(i=0; i<num; i++){
-		
+
 		dataenum=va_arg(ap, int);
-		
+
 		if (this->independents[dataenum]){
 			/*this data has already been checked out! Continue: */
@@ -996,8 +1081,5 @@
 	int     vector_layout = 0;
 	int     counter;
-	int     nods;
-	int     nel;
 	int     numberofelements;
-
 
 	/*variables being fetched: */
@@ -1023,5 +1105,5 @@
 			for (i=0;i<numberofelements;i++){
 				if(this->my_elements[i]){
-					Element* element=(Element*)elements->GetObjectByOffset(counter);
+					Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(counter));
 					element->InputCreate((IssmDouble)boolean,vector_enum,code);
 					counter++;
@@ -1036,5 +1118,5 @@
 			for (i=0;i<numberofelements;i++){
 				if(this->my_elements[i]){
-					Element* element=(Element*)elements->GetObjectByOffset(counter);
+					Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(counter));
 					element->InputCreate((IssmDouble)integer,vector_enum,code);
 					counter++;
@@ -1049,5 +1131,5 @@
 			for (i=0;i<numberofelements;i++){
 				if(this->my_elements[i]){
-					Element* element=(Element*)elements->GetObjectByOffset(counter);
+					Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(counter));
 					element->InputCreate(scalar,vector_enum,code); 
 					counter++;
@@ -1086,5 +1168,5 @@
 			for (i=0;i<numberofelements;i++){
 				if(this->my_elements[i]){
-					Element* element=(Element*)elements->GetObjectByOffset(counter);
+					Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(counter));
 					if(defaulting) element->InputCreate(default_value,vector_enum,code); 
 					else           element->InputCreate(IssmDoublevector,i,this,M,N,vector_layout,vector_enum,code);//we need i to index into elements.
@@ -1124,5 +1206,5 @@
 			for (i=0;i<numberofelements;i++){
 				if(this->my_elements[i]){
-					Element* element=(Element*)elements->GetObjectByOffset(counter);
+					Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(counter));
 					if(defaulting) element->InputCreate(default_value,vector_enum,code); 
 					else           element->InputCreate(IssmDoublevector,i,this,M,N,vector_layout,vector_enum,code);//we need i to index into elements.
@@ -1162,5 +1244,5 @@
 			for (i=0;i<numberofelements;i++){
 				if(this->my_elements[i]){
-					Element* element=(Element*)elements->GetObjectByOffset(counter);
+					Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(counter));
 					if(defaulting) element->InputCreate(default_value,vector_enum,code); 
 					else           element->InputCreate(IssmDoublevector,i,this,M,N,vector_layout,vector_enum,code);//we need i to index into elements.
@@ -1183,7 +1265,10 @@
 void IoModel::LastIndex(int *pindex){
 
-	extern int my_rank;
+	int my_rank;
 	int        lastindex,index;
 	int        record_length;
+
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
 
 	/*Go find in the binary file, the position of the data we want to fetch: */
@@ -1209,5 +1294,5 @@
 	/*Broadcast code and vector type: */
 #ifdef _HAVE_MPI_
-	MPI_Bcast(&lastindex,1,MPI_INT,0,MPI_COMM_WORLD); 
+	MPI_Bcast(&lastindex,1,MPI_INT,0,IssmComm::GetComm()); 
 #endif
 
@@ -1219,12 +1304,14 @@
 FILE* IoModel::SetFilePointerToData(int* pcode,int* pvector_type, int data_enum){
 
-	extern int my_rank;
-	extern int num_procs;
-
-	int found=0;
+	int my_rank;
+
+	int found         = 0;
 	int record_enum;
 	int record_length;
-	int record_code; //1 to 7 number
-	int vector_type; //nodal or elementary
+	int record_code;       //1 to 7 number
+	int vector_type   = 0; //nodal or elementary
+
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
 
 	/*Go find in the binary file, the position of the data we want to fetch: */
@@ -1262,15 +1349,15 @@
 		}
 	}
-#ifdef _HAVE_MPI_
-	MPI_Bcast(&found,1,MPI_INT,0,MPI_COMM_WORLD); 
-	if(!found)_error_("could not find data with name" << " " << EnumToStringx(data_enum) << " ");
-#endif
+	#ifdef _HAVE_MPI_
+	MPI_Bcast(&found,1,MPI_INT,0,IssmComm::GetComm()); 
+	if(!found)_error_("could not find data with name " << EnumToStringx(data_enum) << " in binary file");
+	#endif
 
 	/*Broadcast code and vector type: */
-#ifdef _HAVE_MPI_
-	MPI_Bcast(&record_code,1,MPI_INT,0,MPI_COMM_WORLD); 
-	MPI_Bcast(&vector_type,1,MPI_INT,0,MPI_COMM_WORLD); 
-	if(record_code==5) MPI_Bcast(&vector_type,1,MPI_INT,0,MPI_COMM_WORLD); 
-#endif
+	#ifdef _HAVE_MPI_
+	MPI_Bcast(&record_code,1,MPI_INT,0,IssmComm::GetComm()); 
+	MPI_Bcast(&vector_type,1,MPI_INT,0,IssmComm::GetComm()); 
+	if(record_code==5) MPI_Bcast(&vector_type,1,MPI_INT,0,IssmComm::GetComm()); 
+	#endif
 
 	/*Assign output pointers:*/
@@ -1281,95 +1368,2 @@
 }
 /*}}}*/
-/*FUNCTION IoModel::DeclareIndependents{{{*/
-void IoModel::DeclareIndependents(void){
-
-	bool autodiff=false;
-	int  dummy;
-	int i;
-	int  num_independents;
-	int* independents=NULL;
-
-	#ifdef _HAVE_ADOLC_
-	/*recover independent enums: */
-	this->Constant(&num_independents,AutodiffNumIndependentsEnum);
-	if(num_independents){
-		this->FetchData(&independents,&dummy,&dummy,AutodiffIndependentsEnum);
-
-		/*now go fetch the independent variables for each independent enum: */
-		for(i=0;i<num_independents;i++){
-			this->FetchIndependent(independents[i]);
-		}
-		xDelete<int>(independents);
-	}
-	#else
-	/*if we asked for AD computations, we have a problem!: */
-	this->Constant(&autodiff,AutodiffIsautodiffEnum);
-	if(autodiff)_error_("Cannot carry out AD mode computations without support of ADOLC compiled in!");
-	#endif
-
-}
-/*}}}*/
-/*FUNCTION IoModel::FetchIndependent{{{*/
-void IoModel::FetchIndependent(int independent_enum){
-
-	#ifdef _HAVE_ADOLC_ //cannot come here unless you are running AD mode, from DeclaredIndependents:
-	extern int my_rank;
-	extern int num_procs;
-
-	/*output: */
-	int M,N;
-	IssmPDouble* buffer=NULL; //a buffer to read the data from disk
-	IssmDouble* matrix=NULL; //our independent variable
-	int code=0;
-	int vector_type=0;
-	
-	/*Set file pointer to beginning of the data: */
-	fid=this->SetFilePointerToData(&code,&vector_type,independent_enum);
-	if((code!=5) && (code!=6) && (code!=7))_error_("expecting a IssmDouble, integer or boolean matrix for enum " << EnumToStringx(independent_enum));
-	
-	/*Now fetch: */
-
-	/*We have to read a matrix from disk. First read the dimensions of the matrix, then the whole matrix: */
-	/*numberofelements: */
-	if(my_rank==0){  
-		if(fread(&M,sizeof(int),1,fid)!=1) _error_("could not read number of rows for matrix ");
-	}
-	#ifdef _HAVE_MPI_
-	MPI_Bcast(&M,1,MPI_INT,0,MPI_COMM_WORLD); 
-	#endif
-
-	if(my_rank==0){  
-		if(fread(&N,sizeof(int),1,fid)!=1) _error_("could not read number of columns for matrix ");
-	}
-	#ifdef _HAVE_MPI_
-	MPI_Bcast(&N,1,MPI_INT,0,MPI_COMM_WORLD); 
-	#endif
-
-	/*Now allocate matrix: */
-	if(M*N){
-		buffer=xNew<IssmPDouble>(M*N);
-		matrix=xNew<IssmDouble>(M*N);
-
-		/*Read matrix on node 0, then broadcast: */
-		if(my_rank==0){  
-			if(fread(buffer,M*N*sizeof(IssmPDouble),1,fid)!=1) _error_("could not read matrix ");
-			
-			/*Now, before we even broadcast this to other nodes, declare the whole matrix as a independent variable!: */
-			for (int i=0;i<M*N;++i) matrix[i]<<=buffer[i];  /*we use the <<= ADOLC overloaded operator to declare the independency*/
-		}
-		#ifdef _HAVE_MPI_
-		MPI_Bcast(matrix,M*N,MPI_DOUBLE,0,MPI_COMM_WORLD); 
-		#endif
-		
-		xDelete<IssmPDouble>(buffer);
-	}
-	else _error_("cannot declare the independent variable " << EnumToStringx(independent_enum) <<  "if it's empty!");
-
-	/*Ok, we are almost done. Matrix is now a independent matrix. We don't want this matrix to be fetched again in the 
-	 *future, which would effectively write over the independency in the ADOLC tape! So we are going to keep track of this 
-	 independent matrix inthe iomodel->data[independent_enum] data slot: */
-	this->data[independent_enum]=matrix;
-	this->independents[independent_enum]=true;
- 	#endif
-}
-/*}}}*/
Index: issm/trunk/src/c/classes/IoModel.h
===================================================================
--- issm/trunk/src/c/classes/IoModel.h	(revision 13405)
+++ issm/trunk/src/c/classes/IoModel.h	(revision 13975)
@@ -19,11 +19,11 @@
 
 	private: 
-		Parameters  *constants;   //this dataset holds all IssmDouble, int, bool and char *parameters read in from the input file.*
-	
+		Parameters *constants;   //this dataset holds all IssmDouble, int, bool and char from input
+
 	public:
-		IssmDouble **data;        //this dataset holds temporary data, memory intensive.
-		
+		IssmDouble **data;   //this dataset holds temporary data, memory intensive.
+
 		/*This data needs to stay memory resident at all time, even if it's memory intensive: */
-		FILE *fid;         //pointer to input file
+		FILE *fid;                               //pointer to input file
 		bool *my_elements;
 		bool *my_nodes;
@@ -36,7 +36,8 @@
 		int loadcounter;         //keep track of how many loads are being created in each analysis type
 		int constraintcounter;   //keep track of how many constraints are being created in each analysis type
-		
+
 		/*for AD mode: to keep track of our independent variables we fetch:*/
 		bool* independents;
+		DataSet* independent_objects;
 
 		/*Methods*/
Index: issm/trunk/src/c/classes/IssmComm.cpp
===================================================================
--- issm/trunk/src/c/classes/IssmComm.cpp	(revision 13975)
+++ issm/trunk/src/c/classes/IssmComm.cpp	(revision 13975)
@@ -0,0 +1,46 @@
+/*! \file IssmComm.cpp
+ * \brief  file containing the methods for IssmComm.h
+ */
+
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include "./IssmComm.h"
+#include "../include/types.h"
+
+void IssmComm::SetComm(COMM incomm){ /*{{{*/
+	comm=incomm;
+}/*}}}*/
+COMM IssmComm::GetComm(){  /*{{{*/
+	return comm;
+}/*}}}*/
+int IssmComm::GetRank(){  /*{{{*/
+	int my_rank = 0;
+
+	/*for matlab and python modules, comm == -1*/
+	if((int)comm==-1) return my_rank;
+
+	#ifdef _HAVE_MPI_
+	MPI_Comm_rank(comm,&my_rank);
+	#endif
+
+	return my_rank;
+
+}/*}}}*/
+int IssmComm::GetSize(){  /*{{{*/
+
+	int size = 1;
+
+	/*for matlab and python modules, comm == -1*/
+	if((int)comm==-1) return size;
+
+	#ifdef _HAVE_MPI_
+	MPI_Comm_size(comm,&size);
+	#endif
+
+	return size;
+
+}/*}}}*/
Index: issm/trunk/src/c/classes/IssmComm.h
===================================================================
--- issm/trunk/src/c/classes/IssmComm.h	(revision 13975)
+++ issm/trunk/src/c/classes/IssmComm.h	(revision 13975)
@@ -0,0 +1,31 @@
+/* \file IssmComm.h
+ * \brief  create a class with a static comm, and static methods to access it
+ * This is a way of protecting access to the communicator.
+ */
+
+#ifndef _ISSM_COMM_H
+#define _ISSM_COMM_H
+
+/*{{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include "../include/types.h"
+/*}}}*/
+
+class IssmComm {
+
+	private:
+		static COMM comm;
+
+	public:
+		static void SetComm(COMM incomm);
+		static COMM GetComm();
+		static int GetRank();
+		static int GetSize();
+};
+
+#endif  /* _ISSM_COMM_H */
